# -*- coding: utf-8 -*-
from generator import *

# ========== Spawn ==========
if True:
    # --------- Floor 1 ----------
    s1_00 = Spawn(floor = 1, id = "00", percentage = 50)
    s1_01 = Spawn(floor = 1, id = "01", percentage = 50)
    spawn_1 = [s1_00, s1_01]

    # --------- Floor 2 ----------
    s2_00 = Spawn(floor = 2, id = "00", percentage = 100)
    spawn_2 = [s2_00]

    # --------- Floor 3 ----------

    spawn_3 = []

    spawn = spawn_1 + spawn_2 + spawn_3

# ========== Middle ==========
if True:
    # --------- Floor 1 ----------
    m1_00 = Middle(floor = 1, id = "00", percentage = 13) # 4 arch
    m1_01 = Middle(floor = 1, id = "01", percentage = 12) # 2 floor
    m1_02 = Middle(floor = 1, id = "02", percentage = 6) # simple
    m1_02_secret = Middle(floor = 1, id = "02_secret", percentage = 6) # simple
    m1_03 = Middle(floor = 1, id = "03", percentage = 15) # big
    m1_04 = Middle(floor = 1, id = "04", percentage = 12) # island
    m1_05 = Middle(floor = 1, id = "05", percentage = 12) # cave mid
    m1_06 = Middle(floor = 1, id = "06", percentage = 12) # winding cave
    m1_07 = Middle(floor = 1, id = "07", percentage = 12) # castle circle
    middle_1 = [m1_00, m1_01, m1_02, m1_02_secret, m1_03, m1_04, m1_05, m1_06, m1_07]

    # --------- Floor 2 ----------
    m2_00 = Middle(floor = 2, id = "00", percentage = 20)
    m2_01 = Middle(floor = 2, id = "01", percentage = 20)
    m2_02 = Middle(floor = 2, id = "02", percentage = 20)
    m2_03 = Middle(floor = 2, id = "03", percentage = 20)
    m2_04 = Middle(floor = 2, id = "04", percentage = 20)
    middle_2 = [m2_00, m2_01, m2_02, m2_03, m2_04]

    # --------- Floor 3 ----------

    middle_3 = []

    middle = middle_1 + middle_2 + middle_3

# ========== Armory ==========
if True:
    # --------- Floor 1 ----------
    a1_00 = Armory(floor = 1, id = "00", percentage = 50)
    a1_01 = Armory(floor = 1, id = "01", percentage = 50)
    armory_1 = [a1_00, a1_01]

    # --------- Floor 2 ----------
    a2_00 = Armory(floor = 2, id = "00", percentage = 100)
    armory_2 = [a2_00]

    # --------- Floor 3 ----------

    armory_3 = []

    armory = armory_1 + armory_2 + armory_3

# ========== Boss ============
if True:
    # --------- Floor 1 ----------
    troll_leader = Boss(floor = 1, id = "troll_leader", percentage = 50)
    zeldia_king = Boss(floor = 1, id = "zeldia_king", percentage = 50)
    boss_1 = [troll_leader, zeldia_king]

    # --------- Floor 2 ----------
    spider_queen = Boss(floor = 2, id = "spider_queen", percentage = 50)
    frog_king = Boss(floor = 2, id = "frog_king", percentage = 50)
    boss_2 = [spider_queen, frog_king]

    # --------- Floor 3 ----------

    boss_3 = []

    boss = boss_1 + boss_2 + boss_3

# ========== Wall ============
if True:
    # --------- Floor 1 ----------
    w1_00 = Wall(floor = 1, id = "00", percentage = 50, type = 'castle')
    w1_01 = Wall(floor = 1, id = "01", percentage = 25, type = 'castle')
    w1_02 = Wall(floor = 1, id = "02", percentage = 25, type = 'castle')
    w1_03 = Wall(floor = 1, id = "01", percentage = 50, type = 'cave')
    w1_04 = Wall(floor = 1, id = "02", percentage = 25, type = 'cave')
    w1_05 = Wall(floor = 1, id = "03", percentage = 25, type = 'cave')
    wall_1 = [w1_00, w1_01, w1_02, w1_03, w1_04, w1_05]

    # --------- Floor 2 ----------
    w2_00 = Wall(floor = 2, id = "00", percentage = 50, type = 'forest')
    w2_01 = Wall(floor = 2, id = "01", percentage = 50, type = 'forest')
    wall_2 = [w2_00, w2_01]

    # --------- Floor 3 ----------

    wall_3 = []

    wall = wall_1 + wall_2 + wall_3


rooms = spawn + middle + armory + boss + wall

generator = Generator(rooms)
generator.make()

total = len(spawn) + len(middle) + len(armory) + len(boss)
print('\n\t· Spawn: {0}, Middle: {1}, Armory: {2}, Boss: {3}, Wall: {4}, Total:{5}\n'.format(len(spawn), len(middle), len(armory), len(boss), len(wall), total))
